/*******************************************
*		DLL.h
********************************************/

#ifdef __cplusplus
#undef PLDLL_API
#define PLDLL_API extern "C" __declspec (dllexport)
#else
#define PLDLL_API __declspec (dllexport)
#endif



// Status code
// com
#define STATUS_SUCCESS							0
#define STATUS_OPEN_FAIL						1
#define STATUS_DEVICETYPE_FAIL					2
#define STATUS_NO_HANDLE					    3
#define STATUS_OPEN_TWICE               		4
#define STATUS_CREATEFILE_FAIL			        5
#define STATUS_READ_I2C_FAIL			        6
#define STATUS_NO_DEVICE     			        7
#define STATUS_NO_ALLOCATEDEVICE     			8
#define STATUS_NO_SYS_1               			9
#define STATUS_NO_SYS_2               			10
#define STATUS_No_PL2303_COM_Port               11
#define STATUS_Port_Is_Not_Opened      40

#define STATUS_GPIO_NUMBER_OVERRANGE      20
#define STATUS_GPIO_ENABLE_FAIL      21
#define STATUS_GPIO_SetValue_FAIL      22
#define STATUS_GPIO_GetValue_FAIL    23


#define STATUS_ALREADY_OPEN_FAIL		30
#define SATATUS_I2C_NOT_OPEN			31
#define STATUS_WRITE_ZERO_LEN			32

#define STATUS_WRITE_BELOW_FAIL			34
#define STATUS_WRITE_OVERFLOW_FAIL	    35
#define STATUS_READ_ZERO_LEN			36

#define STATUS_READ_BELOW_FAIL			38
#define STATUS_READ_OVERFLOW_FAIL		39

#define STATUS_CheckChip_FAIL				1101
#define STATUS_Chip_No_Support				1102
#define STATUS_Check_EEPROM_Space_FAIL		1103
#define STATUS_NoEEPROM_SPACE				1104
#define STATUS_EEPROM_NO_Programmed			1105
#define STATUS_WRITE_EEPROM_FAIL			1106
#define STATUS_READ_EEPROM_FAIL				1107
#define SATATUS_EEPROM_NOT_OPEN				1108


//PL2303TB
#define STATUS_PWM_Value_Error              2101
#define STATUS_Clock_Output_ENABLE_FAIL     2102
#define STATUS_Clock_Output_SET_FAIL        2103
#define STATUS_LED_Output_ENABLE_FAIL		2104
#define STATUS_LED_Output_SET_FAIL			2105
#define STATUS_PWM_Output_SET_FAIL			2106



// Device Functions
PLDLL_API int __stdcall Open_Device(); // no use
PLDLL_API int __stdcall Close_Device(void); // no use
PLDLL_API int __stdcall Get_DeviceHandle(HANDLE *handle); // no use

PLDLL_API int __stdcall GetTotalActiveDeviceNumber(int *deviceNumber); 


// DLL function
PLDLL_API int __stdcall Get_DLLversion(int *dllVersion);


//PLDLL_API int __stdcall WriteData(const char *index, const char *data);
//PLDLL_API int __stdcall ReadData(const char *index, BYTE *data);

PLDLL_API int __stdcall PL2303HXD_Open_AllocateDevice(HANDLE *handle,int deviceNumber); 
PLDLL_API int __stdcall PL2303HXD_Close_AllocateDevice(HANDLE handle); 
PLDLL_API int __stdcall PL2303HXD_I2C_WriteData(HANDLE handle,const char *slaveAddress,const char *index, const char *idata_H,const char *idata_L,int len);
PLDLL_API int __stdcall PL2303HXD_I2C_ReadData(HANDLE handle,const char *slaveAddress,const char *index, BYTE *odata_H,BYTE *odata_L,int len);


// PL2303HXD Open / Close Port
PLDLL_API int __stdcall PL2303HXD_GetCOMPort_Address(char *szCOMPortAddress);
PLDLL_API int __stdcall PL2303HXD_Open_Port(LPVOID szCOMPortAddress, HANDLE *hdrv);
PLDLL_API int __stdcall PL2303HXD_Close_Port(HANDLE hdrv);
PLDLL_API int __stdcall PL2303HXD_GetUSBPort_Address_DN(char *szUSBPortAddress,int deviceNumber);
PLDLL_API int __stdcall PL2303HXD_GetCOMPort_Address_DN(char *szCOMPortAddress,int deviceNumber);
PLDLL_API int __stdcall PL2303HXD_GetActiveDeviceNumber(int *activeDeviceNumber); 


// PL2303HXD Get Chip Type
PLDLL_API int __stdcall PL2303_GetChipType(HANDLE hdrv, BYTE *ChipType);


// PL2303HXD GPIO
PLDLL_API int __stdcall PL2303HXD_4GPIO_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303HXD_4GPIO_SetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE val);
PLDLL_API int __stdcall PL2303HXD_4GPIO_GetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE *val);

//PL2303HXD OTP ROM
PLDLL_API int __stdcall PL2303HXD_Read_OTPROM(HANDLE hdrv, BYTE *buff);
PLDLL_API int __stdcall PL2303HXD_Write_OTPROM(HANDLE hdrv, BYTE *buff);


//PL2303TB
PLDLL_API int __stdcall PL2303_Open(char *comStr);
PLDLL_API int __stdcall PL2303_Close(void);

//PL2303TB 12 GPIO
PLDLL_API int __stdcall PL2303_12GPIO_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303_12GPIO_SetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE val);
PLDLL_API int __stdcall PL2303_12GPIO_GetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE *val);


//PL2303TB CLOCK
PLDLL_API int __stdcall PL2303_Enable_Clock_Output(HANDLE hdrv, __int8 Clock_IO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303_SetClock(HANDLE hdrv, __int8 Clock_IO_Num, BYTE val);


//PL2303TB LED
PLDLL_API int __stdcall PL2303_Enable_LED_Output(HANDLE hdrv, __int8 LED_IO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303_SetLED(HANDLE hdrv, __int8 LED_IO_Num, BYTE val);

//PL2303TB PWM
PLDLL_API int __stdcall PL2303_Set_PWM_Output(HANDLE hdrv, __int8 PWM_IO_Num, BYTE *buff);


// PL2303G Open / Close Port
PLDLL_API int __stdcall PL2303G_GetActiveDeviceNumber(int *activeDeviceNumber); 
PLDLL_API int __stdcall PL2303G_GetCOMPort_Address(char *szCOMPortAddress);
PLDLL_API int __stdcall PL2303G_Open_Port(LPVOID szCOMPortAddress, HANDLE *hdrv);
PLDLL_API int __stdcall PL2303G_Close_Port(HANDLE hdrv);


// PL2303G 16 GPIO
PLDLL_API int __stdcall PL2303G_GPIO_A_CNT_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303G_GPIO_A_OUT_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303G_GPIO_A_SetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE val);
PLDLL_API int __stdcall PL2303G_GPIO_A_GetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE *val);

PLDLL_API int __stdcall PL2303G_GPIO_B_CNT_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303G_GPIO_B_OUT_ENABLE(HANDLE hdrv, __int8 GPIO_Num, BOOL Enable);
PLDLL_API int __stdcall PL2303G_GPIO_B_SetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE val);
PLDLL_API int __stdcall PL2303G_GPIO_B_GetValue(HANDLE hdrv, __int8 GPIO_Num, BYTE *val);


//PL2303G W/R OTP/EEPROM
PLDLL_API int __stdcall PL2303G_Read_OTP_EEPROM_ID(HANDLE hdrv, BYTE *data_buff, BYTE *modeSelect);
